package com.jpattern.core;

import java.io.Serializable;
import java.util.Map;

import com.jpattern.service.log.ALoggerServiceBuilder;
import com.jpattern.service.mail.AMailServiceBuilder;

/**
 * 
 * @author Francesco Cina'
 *
 * 29/gen/2011
 */
public interface ISystem extends Serializable {

    void buildService(AServiceBuilder aServiceBuilder);
    
    void buildLoggerService(ALoggerServiceBuilder aLoggerServiceBuilder);
    
    void buildMailService(AMailServiceBuilder aMailServiceBuilder);
    
    void remove(String aServiceName);
    
    void removeAllServices();
    
    boolean contains(String aServiceName);

	Map<String, IService> getServiceMap();
}
