package com.jpattern.core.command;

/**
 * 
 * @author Francesco Cina'
 *
 * 11/set/2011
 */
public class AsyncRollbackCommandWrapper implements Runnable {

	private final ICommand<?> command;
	private final ACommandResult commandResult;
	private final boolean catchRuntimeException;

	AsyncRollbackCommandWrapper(ICommand<?> command, boolean catchRuntimeException, ACommandResult commandResult) {
		this.command = command;
		this.catchRuntimeException = catchRuntimeException;
		this.commandResult = commandResult;
	}
	
	@Override
	public void run() {
		command.doRollback(catchRuntimeException, commandResult);		
	}

}
