package com.jpattern.core.command.facade;

import java.io.Serializable;

import com.jpattern.shared.result.facade.ICommandFacadeResult;

/**
 * 
 * @author Francesco Cina'
 *
 * 25 Feb 2011
 * 
 * This class is used as a entry point for the execution of a chain of commands.
 * 
 */
public abstract class ACommandFacade<E> implements Serializable {

    private static final long serialVersionUID = 1L;


    public final synchronized ICommandFacadeResult<E> exec() {
    	return execute();
    }
    
    protected abstract ICommandFacadeResult<E> execute();
    

}
