package com.jpattern.service.log.reader;

import com.jpattern.core.AServiceBuilder;
import com.jpattern.core.IService;

/**
 * @author Francesco Cinà 07/ago/2009
 */
public class LoggerReaderServiceBuilder extends AServiceBuilder {

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private IQueueMessages _aQueue;

    private String _serviceName;

    public LoggerReaderServiceBuilder(String aServiceName, IQueueMessages aQueue) {
        super(aServiceName);
        _serviceName = aServiceName;
        _aQueue = aQueue;
    }

    public IService build() {
        return new LoggerReaderService(_serviceName, _aQueue);
    }

}
